summaryrefslogtreecommitdiffstats
path: root/src/lib/connections/bond
diff options
context:
space:
mode:
Diffstat (limited to 'src/lib/connections/bond')
-rw-r--r--src/lib/connections/bond40
1 files changed, 40 insertions, 0 deletions
diff --git a/src/lib/connections/bond b/src/lib/connections/bond
new file mode 100644
index 0000000..bc5aa95
--- /dev/null
+++ b/src/lib/connections/bond
@@ -0,0 +1,40 @@
+#! /bin/bash
+. /usr/lib/network/network
+IFENSLAVE="/sbin/ifenslave"
+
+bond_up() {
+ load_profile "$1"
+
+ if [[ -e "/sys/class/net/$INTERFACE" ]]; then
+ report_fail "Interface $INTERFACE already exists."
+ exit 1
+ else
+ ip link add dev $INTERFACE type bond
+ fi
+ bring_interface up "$INTERFACE"
+
+ for slave in "${SLAVE_INTERFACES[@]}"; do
+ bring_interface up "$slave"
+ $IFENSLAVE $INTERFACE $slave
+ done
+
+ "$CONN_DIR/ethernet" up "$1"
+ return 0
+}
+
+bond_down() {
+ load_profile "$1"
+
+ for slave in "${SLAVE_INTERFACES[@]}"; do
+ $IFENSLAVE $INTERFACE -d $slave
+ done
+
+ "$CONN_DIR/ethernet" down "$1"
+ ip link delete "$INTERFACE"
+ return 0
+}
+
+bond_$1 "$2"
+exit $?
+
+# vim: set ts=4 et sw=4: